/* This mod has been generated with PPG-Mod-Creator (https://cheeteau.github.io/PPG-Mod-Creator/). You can remove this comment if you want to, but if someone ever sees this, hi! If you ever wanna support me, feel free to go on my Ko-fi! https://ko-fi.com/cheeteau */
using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using TMPro;
using Unity;
using UnityEngine;
using UnityEngine.Events;
using UnityEngine.SceneManagement;
using UnityEngine.UI;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
            ModAPI.RegisterLiquid(Jellys.Jelly.ID, new Jellys.Jelly());
            ModAPI.RegisterLiquid(BubbleGums.BubbleGum.ID, new BubbleGums.BubbleGum());
			ModAPI.RegisterLiquid(MagmaGums.MagmaGum.ID, new MagmaGums.MagmaGum());
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Jelly Gum Human",
                    DescriptionOverride = "A person who is made up of jelly gum",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bubble-Gum-Human-thumb1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--skin.png");
                        var flesh = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--flesh1.png");
                        var bone = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--bone.png");
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var limb in person.Limbs)
                        {
                            limb.Health = 200f; limb.InitialHealth = 200f; limb.RegenerationSpeed += 20f; limb.BloodLiquidType = "Bubble Gum";
                        }
                    }
                });
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Bubble Gum Human",
                    DescriptionOverride = "A person who is made up of che",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bubble-Gum-Human-thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-skin.png");
                        var flesh = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--flesh.png");
                        var bone = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--bone.png");
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var limb in person.Limbs)
                        {
                            limb.Health = 100f; limb.InitialHealth = 100f; limb.RegenerationSpeed += 10f; limb.BloodLiquidType = "Jelly";
                        }
                    }
                });
			ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Magma Gum Human",
                    DescriptionOverride = "A person who is made up of Magma Gum",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bubble-Gum-Human-thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-skin1.png");
                        var flesh = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--flesh2.png");
                        var bone = ModAPI.LoadTexture("Sprites/Bubble-Gum-Human-Mod--bone.png");
                        var person = Instance.GetComponent<PersonBehaviour>();
                        person.SetBodyTextures(skin, flesh, bone, 1);
                        foreach (var limb in person.Limbs)
                        {
                            limb.Health = 300f; limb.InitialHealth = 300f; limb.RegenerationSpeed += 30f; limb.BloodLiquidType = "Magma Gum";
                        }
                    }
                });
        }
    }
}

public class MagmaGums : SyringeBehaviour
{
    public override string GetLiquidID() => MagmaGum.ID;

    public class MagmaGum : Liquid
    {
        public MagmaGum()
        {
            this.Color = new Color(1f, 1f, 0f, 1f);
        }

        public const string ID = "Magma Gum";

        public override void OnEnterLimb(LimbBehaviour voidlimb)
        {
            if (!voidlimb.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in voidlimb.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                        i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnUpdate(BloodContainer container)
        {
            if (!container.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in container.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
}

public class BubbleGums : SyringeBehaviour
{
    public override string GetLiquidID() => BubbleGum.ID;

    public class BubbleGum : Liquid
    {
        public BubbleGum()
        {
            this.Color = new Color(0.45f, 0.27f, 0.77f, 1f);
        }

        public const string ID = "Bubble Gum";

        public override void OnEnterLimb(LimbBehaviour voidlimb)
        {
            if (!voidlimb.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in voidlimb.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                        i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnUpdate(BloodContainer container)
        {
            if (!container.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in container.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
}

public class Jellys : SyringeBehaviour
{
    public override string GetLiquidID() => Jelly.ID;

    public class Jelly : Liquid
    {
        public Jelly()
        {
            this.Color = new Color(0.16f, 1.24f, 0.56f, 2f);
        }

        public const string ID = "Jelly";

        public override void OnEnterLimb(LimbBehaviour voidlimb)
        {
            if (!voidlimb.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in voidlimb.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnUpdate(BloodContainer container)
        {
            if (!container.gameObject.transform.root.gameObject.GetComponent<PersonBehaviour>().IsAlive())
            {
                foreach (var i in container.gameObject.transform.root.GetComponentsInChildren<LimbBehaviour>())
                {
                    i.gameObject.GetComponent<LimbBehaviour>().Crush();
                }
            }
        }
        public override void OnEnterContainer(BloodContainer container)
        {
        }
        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
}